--[[
 TA Tails (Tails Adventure Tails)
	by WhisperVII (with some help from SRB2 discord)
		Mlem :3
	This is my first ACTUAL character (not counting the edits I did to CDSonic and I've never touched Lua outside of him so
	I can guarantee this code is not optimized in the slightest. 
]]--

addHook("MobjSpawn", function(house)
	local scale = 2*FU
	house.spritexscale, house.spriteyscale = scale, scale
	house.shadowscale = house.scale*2
	if (displayplayer and displayplayer.valid) 
	and displayplayer.mo.skin ~= "tatails"
		house.flags2 = $|MF2_DONTDRAW
	else
		house.flags2 = $&~MF2_DONTDRAW
	end
end, MT_HOUSE)

addHook("MobjThinker", function(mo)
	if not ((displayplayer and displayplayer.valid) and (displayplayer.mo and displayplayer.mo.valid)) return end
	
	if displayplayer.mo.skin ~= "tatails"
		mo.flags2 = $|MF2_DONTDRAW
	else
		mo.flags2 = $&~MF2_DONTDRAW
	end
	
	if consoleplayer.mo.skin == "tatails"
		if (consoleplayer.mo.eflags & MFE_VERTICALFLIP)
			mo.eflags = $1|MFE_VERTICALFLIP -- Considers it flipped
			mo.flags2 = $1|MF2_OBJECTFLIP -- Visually flips it upside down
		end
	end
end, MT_HOUSE)

addHook("TouchSpecial", function(house, mo)
	if (mo
	and mo.valid)
	and mo.skin == "tatails"
		if not mo.player.tailsmenuing
		and (mo.player.cmd.buttons & BT_CUSTOM1)
		and not mo.player.tailshousing
		and (mo.state == S_PLAY_STND or mo.state == S_PLAY_WAIT)
			mo.player.tailshousing = true
			mo.state = S_TAILS_MENU
		end
		if mo.player.tailshousing
			if mo.player.spintapping
				if mo.player.tailshouseselect
					mo.player.tailshouseselect = false
					mo.player.spintapping = false
				elseif not mo.player.tailshouseselect
					mo.state = S_PLAY_STND
					mo.player.tailshousing = false
				end
			end
		end
		if not mo.player.tailsmenuing
		and not mo.player.tailshousing
		and not mo.player.nomorecontrols
			mo.player.housecontrols = true
			mo.player.housecontroltimer = 5*TICRATE
		end
	end
	return true
end, MT_HOUSE)

//This is a very trimmed version of CorpseMod by LightDasher, which is Open Assets
addHook("MobjDeath", function(target, inflictor, source, damagetype)
	if not (target or target.valid or inflictor or inflictor.valid) then return end
	if target.skin ~= "tatails" then return end
	target.deathimpact = 1
end, MT_PLAYER)

//Main Thinker
local hudmlem
addHook("PlayerThink", function(player)

--Lets Setup The Player Variables
	local mo = player.mo
	local skin = "tatails"
	local p = player
	local flighttime = 1
	
	if not ((player and player.valid) and (mo and mo.valid))
	or mo.skin ~= skin
		return
	end
	
	if player.jumptics == nil
        player.jumptics = 0
    end
    if (player.cmd.buttons & BT_JUMP)
        player.jumptics = $1+1
    else
        player.jumptics = 0
    end
	
	player.poweruplist = {
		[1] = "BOMB",
		[2] = "NAPALM",
		[3] = "HELMET",
		[4] = "SHOES",
		[5] = "ROBOT",
		[6] = "RAIDO",
		[7] = "TASONC",
		[8] = "FANG",
		[9] = "TELE",
		[10] = "GLOVE",
		[11] = "NVIS",
		[12] = "TBOMB",
		[13] = "BBOMB",
		[14] = "RADAR"
	}
	
	if not player.tailssetup
		player.tpipebomb = false
		player.upside = false
		player.tasleep = false
		player.tailsrun = false
		player.tailshelmet = false
		player.tailsnapalm = false
		player.tailsraido = false
		player.tailsrobot = false
		player.tailssonic = false
		player.tailsfang = false
		player.tailsteleport = false
		player.tailsglove = false
		player.tailsnight = false
		player.tailstriple = false
		player.tailslarge = false
		player.tailsradar = false
		player.tailsroboting = false
		player.tailssubbing = false
		player.tawarpsub = false
		player.tailsmenuing = false
		player.tailsselect = 1
		player.tapickuptoggle = 1
		player.robotcooldown = 0
		player.tailshousing = false
		player.tailshouseselect = false
		player.tailssignpost = false
		player.freemovetimer = 16
		player.menuselect = 1
		player.hp = 10
		player.hpmax = 10
		player.hp = player.hpmax
		player.hpcounter = 0
		player.tarobohard = 0
		player.tailswaitingtimer = 30*TICRATE
		player.houseselect = "BOMB"
		player.inventory = {}
		player.tailsdevmode = false
		player.tailssetup = true
	end
	
	if player.tailsdevmode
	and not player.tailsdevsetup
		player.tailsrun = true
		player.tailshelmet = true
		player.tailsnapalm = true
		player.tailsraido = true
		player.tailsrobot = true
		player.tailssonic = true
		player.tailsfang = true
		player.tailsteleport = true
		player.tailsglove = true
		player.tailsnight = true
		player.tailstriple = true
		player.tailslarge = true
		player.tailsradar = true
		player.tailsdevsetup = true
	end

	if (player.mo and player.mo.valid)
		if player.hp > player.hpmax
			player.hp = 10
		end
		if player.hp < 0
			player.hp = 0
		end
	end
	
	if player.housecontrols
		player.housecontroltimer = $ - 1
		if player.housecontroltimer == 0
		or player.tailshousing
			player.housecontrols = false
			player.nomorecontrols = true
		end
	end
	
--Don't Duplicate The Items Into The Table
	if not player.youstartwithbomb
		table.insert(player.inventory, player.poweruplist[1])
		player.youstartwithbomb = true
	end
	
	if player.tailsnapalm and not player.napalmobtained
		if not player.inventory[4]
			table.insert(player.inventory,player.poweruplist[2])
		end
		player.napalmobtained = true
	end
	if player.tailshelmet and not player.helmetobtained
		if not player.inventory[4]
			table.insert(player.inventory, player.poweruplist[3])
		end
		player.helmetobtained = true
	end
	if player.tailsrun and not player.shoesobtained
		if not player.inventory[4]
			table.insert(player.inventory, player.poweruplist[4])
		end
		player.shoesobtained = true
	end
	if player.tailsrobot and not player.robotobtained
		if not player.inventory[4]
			table.insert(player.inventory, player.poweruplist[5])
		end
		player.robotobtained = true
	end
	if player.tailsraido and not player.raidoobtained
		if not player.inventory[4]
			table.insert(player.inventory, player.poweruplist[6])
		end
		player.raidoobtained = true
	end
	if player.tailssonic and not player.sonicobtained
		if not player.inventory[4]
			table.insert(player.inventory,player.poweruplist[7])
		end
		player.sonicobtained = true
	end
	if player.tailsfang and not player.tailsfangobtained
		if not player.inventory[4]
			table.insert(player.inventory, player.poweruplist[8])
		end
		player.tailsfangobtained = true
	end
	if player.tailsteleport and not player.tailsteleportobtained
		if not player.inventory[4]
			table.insert(player.inventory, player.poweruplist[9])
		end
		player.tailsteleportobtained = true
	end
	if player.tailsglove and not player.tailsgloveobtained
		if not player.inventory[4]
			table.insert(player.inventory, player.poweruplist[10])
		end
		player.tailsgloveobtained = true
	end
	if player.tailsnight and not player.tailsnightobtained
		if not player.inventory[4]
			table.insert(player.inventory, player.poweruplist[11])
		end
		player.tailsnightobtained = true
	end
	if player.tailstriple and not player.tailstripletrouble
		if not player.inventory[4]
			table.insert(player.inventory, player.poweruplist[12])
		end
		player.tailstripletrouble = true
	end
	if player.tailslarge and not player.tailslargeobtained
		if not player.inventory[4]
			table.insert(player.inventory, player.poweruplist[13])
		end
		player.tailslargeobtained = true
	end
	if player.tailsradar and not player.tailsradarobtained
		if not player.inventory[14]
			table.insert(player.inventory, player.poweruplist[14])
		end
		player.tailsradarobtained = true
	end
	
--Menu Activation
	if (player.cmd.buttons & BT_CUSTOM3)
	and not player.tailsmenuing
	and not player.tailshousing
	and not player.tailsroboting
	and not player.tailssubbing
	and not player.tailspin
	and not mo.tpipebomb
	and not mo.upside
	and P_IsObjectOnGround(mo)
	and not player.exiting
	and not player.tapickup
	and player.mo.state ~= S_PLAY_SPINDASH
		player.mo.state = S_TAILS_MENU
		player.tailsmenuing = true
		if player.sounding == 0
			S_StartSound(mo, sfx_kc63)
			player.sounding = 1
		end
	end
--Pickup Animation Controls
	if player.tapickup
		mo.momx = 0*mo.scale
		mo.momy = 0*mo.scale
		mo.momz = 0*mo.scale
		if player.mo.state == S_TAILS_AWAY
			player.freemovetimer = $ - 1
			if player.freemovetimer == 0
				player.tapickup = false
				player.freemovetimer = 16
			end
		end
	end
--Tails' House Plays The Music
	if player.tailshousing
	and S_MusicName(player) ~= "TATH"
		S_ChangeMusic("TATH", true, p)
	end
	
	if player.tailshousing
		player.powers[pw_flashing] = 1
	end
	
	if not player.tailshousing
	and S_MusicName(player) == "TATH"
		P_RestoreMusic(player)
	end
	
--Stop Jumping When Selecting
	if p.mo and p.mo.valid
	and p.tailsjumpwait >= 1
		p.tailsjumpwait = $1+1
	end
	if p.tailsjumpwait >= 5
		p.tailsjumpwait = 0
	end
	if (P_PlayerInPain(p) or p.playerstate == PST_DEAD or p.powers[pw_carry] or p.mo.skin ~= "tatails")
		p.tailsjumpwait = 0
	end
	
--Tails Be Spinning
	if p.tailspin == nil
		p.tailspin = false
	end

	if (p.cmd.buttons & BT_CUSTOM2 
	and not p.tailspin 
	and not p.upside 
	and not p.tailsmenuing
	and mo.state ~=S_UPSIDE 
	and mo.state ~= S_PLAY_FLY 
	and mo.state ~= S_PLAY_JUMP
	and mo.state ~= S_PLAY_FALL
	and mo.state ~= S_PLAY_SPINDASH
	and mo.state ~= S_PLAY_ROLL
	and not player.tapickup
	and p.speed == 0 
	and not p.tailsroboting)
		mo.state = S_TAILSPIN
		p.tailspin = true
		if S_MusicName(p) ~= "TSPIN"
            S_ChangeMusic("TSPIN", true, p)
		end
	end
	if p.tailspin     
        if p.speed ~= 0 or mo.state ~= S_TAILSPIN
			mo.state = S_PLAY_STND
            p.tailspin = false
			if S_MusicName(p) == "TSPIN"
				P_RestoreMusic(p)
			end
        end
		if not P_IsObjectOnGround(mo)
			p.tailspin = false
			mo.state = S_PLAY_JUMP
			if S_MusicName(p) == "TSPIN"
				P_RestoreMusic(p)
			end
		end
    end
	
--Flight Time Adjuster
	if player.isflying and player.onground
		player.isflying = false
		player.onground = false

		-- For every emerald collected, gain 2 extra seconds of flight
		for i, em in ipairs({EMERALD1, EMERALD2, EMERALD3, EMERALD4, EMERALD5, EMERALD6, EMERALD7}) do
			if emeralds & em then flighttime = i * 2 end
			player.powers[pw_tailsfly] = flighttime*TICRATE
		end
		-- If you're super, you have "infinite" flight
		if player.powers[pw_super]
		or player.tailsroboting
			player.powers[pw_tailsfly] = 999*TICRATE
		end
		
		if player.bot == BOT_2PAI
			player.powers[pw_tailsfly] = 8*TICRATE
		end
	end
	
	if player.powers[pw_tailsfly] == 0
	and (P_IsObjectOnGround(mo) or player.powers[pw_carry] or mo.state == S_PLAY_RIDE or mo.state == S_PLAY_FLY_TIRED)
	or not (P_IsObjectOnGround and mo.state == S_PLAY_FLY)
		player.onground = true
	end
	
--Victory Animation
	if p.exiting
	and p.speed == 0
	and P_IsObjectOnGround(mo)
	and (mo.state == S_PLAY_STND or mo.state == S_PLAY_WAIT)
		mo.state = S_TVICTORY1
	end
	
--Chat Phrase Animations
	if mo.tpipebomb then        
        if p.speed ~= 0 or mo.state ~= S_TPIPE then
			mo.state = S_PLAY_STND
            mo.tpipebomb = false
            if S_MusicName(p) == "PIPEB" then
                P_RestoreMusic(p)
            end
        end
		if not P_IsObjectOnGround(mo)
			mo.state = S_PLAY_JUMP
			mo.tpipebomb = false
			if S_MusicName(p) == "PIPEB" then
                P_RestoreMusic(p)
            end
		end
    end
	
	if mo.upside
		if p.speed ~= 0 or mo.state ~= S_UPSIDE
			mo.state = S_PLAY_STND
			mo.upside = false
			if S_MusicName(p) == "TUPS"
				P_RestoreMusic(p)
			end
		end
		if not P_IsObjectOnGround(mo)
			mo.state = S_PLAY_JUMP
			mo.upside = false
			if S_MusicName(p) == "TUPS" then
                P_RestoreMusic(p)
            end
		end
	end
	
	if mo.tasleep 
		if not netgame
			S_ChangeMusic("TAZZZ", true)
		end
		if p.speed ~= 0 
		and ((mo.state ~= S_TAILS_SLEEP or mo.state ~= S_TAILS_SLEEP2) or (mo2.state ~= S_TAILS_SLEEP or mo2.state ~= S_TAILS_SLEEP2))
			mo.state = S_PLAY_STND
			mo.tasleep = false
			p.mo.spritexscale = FU
			p.mo.spriteyscale = FU
			if S_MusicName(p) == "TAZZZ"
				P_RestoreMusic(p)
				P_RestoreMusic(consoleplayer)
			end
		end
		if not P_IsObjectOnGround(mo)
			mo.state = S_PLAY_JUMP
			mo.tasleep = false
			p.mo.spritexscale = FU
			p.mo.spriteyscale = FU
			if S_MusicName(p) == "TAZZZ"
				P_RestoreMusic(p)
				P_RestoreMusic(consoleplayer)
			end
		end
	end
	
	if player.mo.state == S_PLAY_WAIT
		player.tailswaitingtimer = $ - 1
		if player.tailswaitingtimer == 1
			player.mo.state = S_TAILS_SLEEP
			player.mo.tasleep = true
			player.tailswaitingtimer = 0
		end
	else
		player.tailswaitingtimer = 30*TICRATE
	end
	
-- This is a very trimmed portion of CorpseMod by LightDasher, which is Open Assets
	if mo.deathimpact == 1
		mo.fuse = FRACUNIT
		P_SetObjectMomZ(mo, 0, false)
		mo.flags = $ & ~MF_NOCLIPHEIGHT
		mo.deathimpact = 2
	elseif mo.deathimpact == 2
		if P_IsObjectOnGround(mo)
			-- If in pit, reset vars and return (no corpse)
			if P_CheckDeathPitCollide(mo)
				mo.deathimpact = nil
				mo.fuse = 0
				return
			end
			local corpse = P_SpawnGhostMobj(mo)
			corpse.scale = 4*FU/3
			corpse.from_player = true
			corpse.fuse = 550
			corpse.rollangle = 0
			corpse.color = mo.color
			corpse.state = S_TAILS_DEAD
			corpse.shadowscale = mo.shadowscale
			S_StartSound(mo, sfx_s3k5d)
			P_InstaThrust(mo, 0, 0)
			mo.deathimpact = nil
			mo.fuse = 0
		end
	end
end)

//Players around Sleepy Tails can hear music too. Thanks Amperbee
addHook("ThinkFrame", do
	local nearbyAsleep = false -- holds whether someone is nearby and hoooonk mimimi hooonk mimimimi
	local playingSleepMusic = (S_MusicName(consoleplayer) == "TAZZZ") -- holds whether we're playing The Music
	if not ((displayplayer and displayplayer.valid) and (displayplayer.mo and displayplayer.mo.valid)) return end

	for otherp in players.iterate do -- start looking for nearby players
		local dist = FixedHypot(FixedHypot(displayplayer.mo.x - otherp.mo.x, displayplayer.mo.y - otherp.mo.y), displayplayer.mo.z - otherp.mo.z)

		-- add a skin check here
		if dist > 220*FU then continue end -- other player is too far, don't care
		if otherp.mo.tasleep then nearbyAsleep = true end -- they're sleepy and they're nearby, so nearbyAsleep must become true
	end

	if nearbyAsleep then
		if not playingSleepMusic then S_ChangeMusic("TAZZZ", true, consoleplayer) end
	else
		if playingSleepMusic then P_RestoreMusic(consoleplayer) end
	end
end)

addHook("JumpSpecial", function(p)
    if p.mo and p.mo.valid
    and p.mo.skin == "tatails"
    and p.tailsjumpwait
		return true
    end
end)

//HUD Stuff
hud.add(function(v, player)
	local mo = player.mo
	local skin = "tatails"
	
	if not ((player and player.valid) and (mo and mo.valid))
	or mo.skin ~= skin
	and not G_IsSpecialStage()
		return
	end
	
	if player.mo.skin == skin
		if player.tailsdevmode
			v.drawString(170, -7, "TA DEV MODE ENABLED", V_PERPLAYER, "center")
		end
		
		v.drawScaled(22*FU, 56*FU, 2*FU/3, v.cachePatch("TAHEALTH"..(leveltime/5) % 4), V_SNAPTOTOP|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS)
		if player.hp != nil
			v.drawNum(64, 62, player.hp, V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER|V_HUDTRANS, "center")
		end
		
		if player.inventory == nil return end
		if player.inventory[player.tailsselect] == "BOMB"
			hudmlem = "PWBB"
		elseif player.inventory[player.tailsselect] == "NAPALM"
			hudmlem = "PWNP"
		elseif player.inventory[player.tailsselect] == "HELMET"
			hudmlem = "PWHM"
		elseif player.inventory[player.tailsselect] == "SHOES"
			hudmlem = "PWRN"
		elseif player.inventory[player.tailsselect] == "ROBOT"
			hudmlem = "PWRB"
		elseif player.inventory[player.tailsselect] == "RAIDO"
			hudmlem = "PWRD"
		elseif player.inventory[player.tailsselect] == "TASONC"
			hudmlem = "PWSC"
		elseif player.inventory[player.tailsselect] == "FANG"
			hudmlem = "PWFG"
		elseif player.inventory[player.tailsselect] == "TELE"
			hudmlem = "PWTL"
		elseif player.inventory[player.tailsselect] == "GLOVE"
			hudmlem = "PWGL"
		elseif player.inventory[player.tailsselect] == "NVIS"
			hudmlem = "PWNV"
		elseif player.inventory[player.tailsselect] == "TBOMB"
			hudmlem = "PWTB"
		elseif player.inventory[player.tailsselect] == "BBOMB"
			hudmlem = "PWBI"
		elseif player.inventory[player.tailsselect] == "RADAR"
			hudmlem = "PWRR"
		end
		if player.tailssubbing
		and hudmlem != "PWMS"
			hudmlem = "PWMS"
		end
		
		local pownull = v.cachePatch("TANULL")
		local box = v.cachePatch("BOX")
		local cash = v.cachePatch
		local housefpp = V_SNAPTOLEFT|V_SNAPTOTOP|V_PERPLAYER
		local menufpp = V_SNAPTOLEFT|V_SNAPTOBOTTOM|V_PERPLAYER
	
		if player.tailsmenuing
			v.drawString(155, 90, "Press Jump to select", V_PERPLAYER|V_YELLOWMAP, "thin-center")
			v.drawString(155, 100, "Press Spin to cancel", V_PERPLAYER|V_YELLOWMAP, "thin-center")
			v.drawScaled(80*FRACUNIT, 30*FRACUNIT, FRACUNIT/1, v.cachePatch("TAMENU"), V_PERPLAYER)
			if player.inventory[1]
				v.draw(88, 50, v.cachePatch(player.inventory[1]), V_PERPLAYER)
			else
				v.draw(88, 50, pownull, V_PERPLAYER)
			end
			if player.inventory[2]
				v.draw(125, 50, v.cachePatch(player.inventory[2]), V_PERPLAYER)
			else
				v.draw(125, 50, pownull, V_PERPLAYER)
			end
			if player.inventory[3]
				v.draw(162, 50, v.cachePatch(player.inventory[3]), V_PERPLAYER)
			else
				v.draw(162, 50, pownull, V_PERPLAYER)
			end
			if player.inventory[4]
				v.draw(199, 50, v.cachePatch(player.inventory[4]), V_PERPLAYER)
			else
				v.draw(199, 50, pownull, V_PERPLAYER)
			end
			
			if player.powitem == 1
				v.draw(86, 48, box, V_PERPLAYER)
			end
			if player.powitem == 2
				v.draw(123, 48, box, V_PERPLAYER)
			end
			if player.powitem == 3
				v.draw(160, 48, box, V_PERPLAYER)
			end
			if player.powitem == 4
				v.draw(197, 48, box, V_PERPLAYER)
			end
		end
		
		if player.tailshousing
			local hs = (v.width()*FRACUNIT)/320
			local vs = (v.height()*FRACUNIT)/288
			v.drawStretched(0, 0, hs, vs, cash("TAHOUSE"), V_SNAPTOLEFT|V_SNAPTOTOP|V_NOSCALEPATCH)
			--------------------Top Layer---------------------
			v.draw(56, 53, cash("BOMB"), housefpp) -- Bomb
			
			--Big Bomb
			if player.tailslarge
				v.draw(96, 53, cash("BBOMB"), housefpp)
			else
				v.draw(96, 53, pownull, housefpp)
			end
			
			--Napalm
			if player.tailsnapalm
				v.draw(136, 53, cash("NAPALM"), housefpp)
			else
				v.draw(136, 53, pownull, housefpp)
			end
			
			--Teleport
			if player.tailsteleport
				v.draw(176, 53, cash("TELE"), housefpp)
			else
				v.draw(176, 53, pownull, housefpp)
			end
			
			--Night Vision
			if player.tailsnight
				v.draw(216, 52, cash("NVIS"), housefpp)
			else
				v.draw(216, 53, pownull, housefpp)
			end
			
			--Shoes
			if player.tailsrun
				v.draw(256, 53, cash("SHOES"), housefpp)
			else
				v.draw(256, 53, pownull, housefpp)
			end
			
			--Raido
			if player.tailsraido
				v.draw(296, 54, cash("RAIDO"), housefpp)
			else
				v.draw(296, 53, pownull, housefpp)
			end
			----------------- Bottom Layer --------------------
			--Triple Bomb
			if player.tailstriple
				v.draw(56, 94, cash("TBOMB"), housefpp)
			else
				v.draw(56, 94, pownull, housefpp)
			end
			
			--Helmet
			if player.tailshelmet
				v.draw(96, 94, cash("HELMET"), housefpp)
			else
				v.draw(96, 94, pownull, housefpp)
			end
			
			--Robot
			if player.tailsrobot
				v.draw(136, 94, cash("ROBOT"), housefpp)
			else
				v.draw(136, 94, pownull, housefpp)
			end
			
			--Glove
			if player.tailsglove
				v.draw(176, 94, cash("GLOVE"), housefpp)
			else
				v.draw(176, 94, pownull, housefpp)
			end
			
			--Fang
			if player.tailsfang
				v.draw(216, 94, cash("FANG"), housefpp)
			else
				v.draw(216, 94, pownull, housefpp)
			end
			
			--Sonic (Spindash)
			if player.tailssonic
				v.draw(256, 94, cash("TASONC"), housefpp)
			else
				v.draw(256, 94, pownull, housefpp)
			end
			
			--Radar
			if player.tailsradar
				v.draw(296, 94, cash("RADAR"), housefpp)
			else
				v.draw(296, 94, pownull, housefpp)
			end
			--------------------Inventory----------------------
			v.draw(114, 130, cash(player.inventory[1]), menufpp)
			if player.inventory[2]
				v.draw(154, 130, cash(player.inventory[2]), menufpp)
			else
				v.draw(154, 130, pownull, menufpp)
			end
			if player.inventory[3]
				v.draw(194, 130, cash(player.inventory[3]), menufpp)
			else
				v.draw(194, 130, pownull, menufpp)
			end
			if player.inventory[4]
				v.draw(234, 130, cash(player.inventory[4]), menufpp)
			else
				v.draw(234, 130, pownull, menufpp)
			end
			----------------------Boxes------------------------
			if player.menuselect == 1
				v.draw(112, 128, box, menufpp)
			elseif player.menuselect == 2
				v.draw(152, 128, box, menufpp)
			elseif player.menuselect == 3
				v.draw(192, 128, box, menufpp)
			elseif player.menuselect == 4
				v.draw(232, 128, box, menufpp)
			end
			if not player.tailshouseselect
				return
			elseif player.houseselect == "BOMB"
				v.draw(54, 51, box, housefpp)
				v.drawString(88, 179, "Bombs: Your default weapon. Press Fire to throw", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, "thin")
			elseif player.houseselect == "BBOMB"
				v.draw(94, 51, box, housefpp)
				if player.tailslarge
					v.drawString(44, 179, "Large Bomb: Large Bombs that explode on a delay. Press Fire to throw", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, "thin")
				end
			elseif player.houseselect == "NAPALM"
				v.draw(134, 51, box, housefpp)
				if player.tailsnapalm
					v.drawString(30, 179, "Napalm: Throws a bomb that explodes as fiery pillar. Press Fire to throw", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, "thin")
				end
			elseif player.houseselect == "TELE"
				v.draw(174, 51, box, housefpp)
				if player.tailsteleport
					v.drawString(38, 179, "Teleport: Hold Fire to begin spinning. Hold long enough to warp home.", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, "thin")
				end
			elseif player.houseselect == "NVIS"
				v.draw(214, 51, box, housefpp)
				if player.tailsnight
					v.drawString(96, 179, "Night Vision: Equip to light up dark areas", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, "thin")
				end
			elseif player.houseselect == "SHOES"
				v.draw(254, 51, box, housefpp)
				if player.tailsrun
					v.drawString(44, 179, "Speed Boots: Equip to accelerate faster and have a higher run speed", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, "thin")
				end
			elseif player.houseselect == "RAIDO"
				v.draw(294, 51, box, housefpp)
				if player.tailsraido
					v.drawString(45, 179, "Raido: Next/PrevWeapon to scroll. Fire to listen; Tossflag to stop", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, "thin")
				end
			elseif player.houseselect == "TBOMB"
				v.draw(54, 92, box, housefpp)
				if player.tailstriple
					v.drawString(62, 179, "Triple Bomb: Throws 3 bombs in a spread. Press Fire to Throw", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, "thin")
				end
			elseif player.houseselect == "HELMET"
				v.draw(94, 92, box, housefpp)
				if player.tailshelmet
					v.drawString(32, 179, "Helmet: Press Fire to shield yourself. Use it in the air to badnik bounce", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, "thin")
				end
			elseif player.houseselect == "ROBOT"
				v.draw(134, 92, box, housefpp)
				if player.tailsrobot
					v.drawString(36, 179, "Remote Robot: Fire to call out; Spin to call back. Transforms in water", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, "thin")
				end
			elseif player.houseselect == "GLOVE"
				v.draw(174, 92, box, housefpp)
				if player.tailsglove
					v.drawString(70, 179, "Glove: Press Fire to pick up nearby objects and enemies", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, "thin")
				end
			elseif player.houseselect == "FANG"
				v.draw(214, 92, box, housefpp)
				if player.tailsfang
					v.drawString(74, 179, "Fang: While in inventory, increases ring drop chance", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, "thin")
				end
			elseif player.houseselect == "TASONC"
				v.draw(254, 92, box, housefpp)
				if player.tailssonic
					v.drawString(75, 179, "Sonic: Equip to gain a spindash. Can't enter spin gaps", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, "thin")
				end
			elseif player.houseselect == "RADAR"
				v.draw(294, 92, box, housefpp)
				if player.tailsradar
					v.drawString(104, 179, "Radar: Equip to locate nearby powerups", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, "thin")
				end
			end
		end
		
		if player.tapickup
			v.draw(105, 155, cash("TABAR"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER)
			v.drawString(195, 155, ((player.justpickedup) + " Obtained"), V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER, "center")
		end
			
		if not player.tailshousing
			v.drawString(15, 146, "Current Powerup:", V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT, "small-thin-center")
			v.cachePatch(hudmlem)
			v.drawScaled(24*FRACUNIT, 162*FRACUNIT, FRACUNIT/2, v.getSpritePatch(hudmlem), V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		end
		
		if player.housecontrols
			v.drawString(70, 150, "Press Custom1 to open the house menu", V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
		end
	end
end, "game")

//Menu Things
addHook("PreThinkFrame", do
	for player in players.iterate
		local mo = player.mo
		local p = player
		if not ((player and player.valid) and (mo and mo.valid))
		or mo.skin ~= "tatails"
		or p.bot == BOT_2PAI
			continue
		end
		
		--I'm gonna hijack this for the spindash and roll states to not change height
		--Probably doesn't HAVE to be in a PreThinkFrame but eh
		if mo.state == S_PLAY_SPINDASH
		or mo.state == S_PLAY_ROLL
			player.spinheight = player.height
		end
		
		if player.tailsjumpwait == nil
			player.tailsjumpwait = 0
		end
		
		if player.tailsmenuing
		or player.tailshousing
		or player.tailsjumpwait > 0
			player.pflags = $|PF_FULLSTASIS
		end
		
		--Next Weapon Check
		if not (player.cmd.buttons & BT_WEAPONNEXT)
			player.nextready = true
			player.nexttapping = false
		elseif player.nextready
			player.nexttapping = true
			player.nextready = false
		else
			player.nexttapping = false
		end
		
		--Previous Weapon Check
		if not (player.cmd.buttons & BT_WEAPONPREV)
			player.prevready = true
			player.prevtapping = false
		elseif player.prevready
			player.prevtapping = true
			player.prevready = false
		else
			player.prevtapping = false
		end
		
		--You don't have to open the menu to swap powerups
		if player.nexttapping
		and player.inventory[player.tailsselect] ~= "RAIDO"
			if player.tapickup
			or player.tailsroboting
			or player.tailssubbing
				continue
			end
			if player.inventory[1]
			and not (player.inventory[2] or player.inventory[3] or player.inventory[4])
				continue
			end
			S_StartSound(nil, sfx_switch, p)
			if player.inventory[2]
			and not (player.inventory[3] or player.inventory[4])
				if player.tailsselect == 2
					player.tailsselect = 1
				else
					player.tailsselect = $ + 1
				end
			end
			if player.inventory[3]
			and not player.inventory[4]
				if player.tailsselect == 3
					player.tailsselect = 1
				else
					player.tailsselect = $ + 1
				end
			end
			if player.inventory[4]
				if player.tailsselect == 4
					player.tailsselect = 1
				else
					player.tailsselect = $ + 1
				end
			end
		end
		if player.prevtapping
		and player.inventory[player.tailsselect] ~= "RAIDO"
			if player.tapickup
			or player.tailsroboting
			or player.tailssubbing
				continue
			end
			if player.inventory[1]
			and not (player.inventory[2] or player.inventory[3] or player.inventory[4])
				continue
			end 
			S_StartSound(nil, sfx_switch, p)
			if player.inventory[2]
			and not (player.inventory[3] or player.inventory[4])
				if player.tailsselect == 1
					player.tailsselect = 2
				else
					player.tailsselect = $ - 1
				end
			end
			if player.inventory[3]
			and not player.inventory[4]
				if player.tailsselect == 1
					player.tailsselect = 3
				else
					player.tailsselect = $ - 1
				end
			end
			if player.inventory[4]
				if player.tailsselect == 1
					player.tailsselect = 4
				else
					player.tailsselect = $ - 1
				end
			end
		end
		
		if p.powitem == nil
			p.powitem = 1
		end
		
		//So the sound doesn't play every tic the menu is open
		if p.sounding == nil
			p.sounding = 0
		end
		
		//Right Button Check
		if p.cmd.sidemove < 25
			p.rightready = true
			p.righttapping = false
		elseif p.rightready
			p.righttapping = true
			p.rightready = false
		else
			p.righttapping = false
		end
	
		//Left Button Check
		if p.cmd.sidemove > -25
			p.leftready = true
			p.lefttapping = false
		elseif p.leftready
			p.lefttapping = true
			p.leftready = false
		else
			p.lefttapping = false
		end
		
		//Up Button Check
		if p.cmd.forwardmove < 25
			p.upready = true
			p.uptapping = false
		elseif p.upready
			p.uptapping = true
			p.upready = false
		else
			p.uptapping = false
		end
		
		//Down Button Check
		if p.cmd.forwardmove > -25
			p.downready = true
			p.downtapping = false
		elseif p.downready
			p.downtapping = true
			p.downready = false
		else
			p.downtapping = false
		end
		
		//Spin Press Check
		if not (p.cmd.buttons & BT_USE)
			p.spinready = true
			p.spintapping = false
		elseif p.spinready
			p.spintapping = true
			p.spinready = false
		else
			p.spintapping = false
		end
		
		if p.tailsmenuing
			if p.lefttapping
				S_StartSound(nil, sfx_menu1, p)
				if p.powitem == 1
					p.powitem = 4
				else
					p.powitem = $ - 1
				end
			end
			if p.righttapping
				S_StartSound(nil, sfx_menu1, p)
				if p.powitem == 4
					p.powitem = 1
				else
					p.powitem = $ + 1
				end
			end
			//If you're in a scenario where the menu SHOULD close, then close it
			if (mo.state == S_PLAY_DEAD
			or mo.state == S_PLAY_DRWN
			or P_PlayerInPain(p)
			or p.powers[pw_carry]
			or mo.state == S_PLAY_ROLL
			or p.exiting)
				p.tailsmenuing = false
				p.sounding = 0
			end
			//Otherwise close it with buttons
			if p.jumptics == 1
				if p.powitem == 1
					S_StartSound(nil, sfx_slect, p)
					p.tailsselect = 1
				elseif p.powitem == 2
					if not p.inventory[2]
						S_StartSound(nil, sfx_lose, p)
						return false
					else
						S_StartSound(nil, sfx_slect, p)
					end
					p.tailsselect = 2
				elseif p.powitem == 3
					if not p.inventory[3]
						S_StartSound(nil, sfx_lose, p)
						return false
					else
						S_StartSound(nil, sfx_slect, p)
					end
					p.tailsselect = 3
				elseif p.powitem == 4
					if not p.inventory[4]
						S_StartSound(nil, sfx_lose, p)
						return false
					else
						S_StartSound(nil, sfx_slect, p)
					end
					p.tailsselect = 4
				end
				p.tailsjumpwait = 1
				p.tailsmenuing = false
				p.sounding = 0
				mo.state = S_PLAY_STND
			end
			if p.cmd.buttons & BT_USE
				mo.state = S_PLAY_STND
				p.tailsmenuing = false
				p.sounding = 0
			end
		end
		
		if p.tailshousing
			if not p.tailshouseselect
			and p.jumptics == 1
				S_StartSound(nil, sfx_slect, p)
				p.tailshouseselect = true
			elseif p.tailshouseselect
			and p.jumptics == 1
				S_StartSound(nil, sfx_enter, p)
				if (p.houseselect == "NAPALM"
				and not p.tailsnapalm)
				or (p.houseselect == "SHOES"
				and not p.tailsrun)
				or (p.houseselect == "RAIDO"
				and not p.tailsraido)
				or (p.houseselect == "HELMET"
				and not p.tailshelmet)
				or (p.houseselect == "ROBOT"
				and not p.tailsrobot)
				or (p.houseselect == "TASONC"
				and not p.tailssonic)
				or (p.houseselect == "FANG"
				and not p.tailsfang)
				or (p.houseselect == "TBOMB"
				and not p.tailstriple)
				or (p.houseselect == "GLOVE"
				and not p.tailsglove)
				or (p.houseselect == "NVIS"
				and not p.tailsnight)
				or (p.houseselect == "BBOMB"
				and not p.tailslarge)
				or (p.houseselect == "RADAR"
				and not p.tailsradar)
				or (p.houseselect == "TELE"
				and not p.tailsteleport)
					S_StartSound(nil, sfx_lose, p)
				else
					p.tailshouseselect = false
					table.remove(p.inventory, p.menuselect)
					table.insert(p.inventory, p.menuselect, p.houseselect)
				end
			end
			
			if not p.tailshouseselect
				if p.righttapping
					S_StartSound(nil, sfx_menu1, p)
					if p.menuselect == 4
						p.menuselect = 1
					else
						p.menuselect = $ + 1
					end
				end
				if p.lefttapping
					S_StartSound(nil, sfx_menu1, p)
					if p.menuselect == 1
						p.menuselect = 4
					else
						p.menuselect = $ - 1
					end
				end
			end
			if p.tailshouseselect then
				if p.lefttapping then
					S_StartSound(nil, sfx_menu1, p)
					if p.houseselect == "BOMB"
						p.houseselect = "RAIDO"
					elseif p.houseselect == "BBOMB"
						p.houseselect = "BOMB"
					elseif p.houseselect == "NAPALM"
						p.houseselect = "BBOMB"
					elseif p.houseselect == "TELE"
						p.houseselect = "NAPALM"
					elseif p.houseselect == "NVIS"
						p.houseselect = "TELE"
					elseif p.houseselect == "SHOES"
						p.houseselect = "NVIS"
					elseif p.houseselect == "RAIDO"
						p.houseselect = "SHOES"
					elseif p.houseselect == "TBOMB"
						p.houseselect = "RADAR"
					elseif p.houseselect == "HELMET"
						p.houseselect = "TBOMB"
					elseif p.houseselect == "ROBOT"
						p.houseselect = "HELMET"
					elseif p.houseselect == "GLOVE"
						p.houseselect = "ROBOT"
					elseif p.houseselect == "FANG"
						p.houseselect = "GLOVE"
					elseif p.houseselect == "TASONC"
						p.houseselect = "FANG"
					elseif p.houseselect == "RADAR"
						p.houseselect = "TASONC"
					end
				end
				if p.righttapping then
					S_StartSound(nil, sfx_menu1, p)
					if p.houseselect == "BOMB"
						p.houseselect = "BBOMB"
					elseif p.houseselect == "BBOMB"
						p.houseselect = "NAPALM"
					elseif p.houseselect == "NAPALM"
						p.houseselect = "TELE"
					elseif p.houseselect == "TELE"
						p.houseselect = "NVIS"
					elseif p.houseselect == "NVIS"
						p.houseselect = "SHOES"
					elseif p.houseselect == "SHOES"
						p.houseselect = "RAIDO"
					elseif p.houseselect == "RAIDO"
						p.houseselect = "BOMB"
					elseif p.houseselect == "TBOMB"
						p.houseselect = "HELMET"
					elseif p.houseselect == "HELMET"
						p.houseselect = "ROBOT"
					elseif p.houseselect == "ROBOT"
						p.houseselect = "GLOVE"
					elseif p.houseselect == "GLOVE"
						p.houseselect = "FANG"
					elseif p.houseselect == "FANG"
						p.houseselect = "TASONC"
					elseif p.houseselect == "TASONC"
						p.houseselect = "RADAR"
					elseif p.houseselect == "RADAR"
						p.houseselect = "TBOMB"
					end
				end
				if p.uptapping then
					S_StartSound(nil, sfx_menu1, p)
					if p.houseselect == "TBOMB"
						p.houseselect = "BOMB"
					elseif p.houseselect == "HELMET"
						p.houseselect = "BBOMB"
					elseif p.houseselect == "ROBOT"
						p.houseselect = "NAPALM"
					elseif p.houseselect == "GLOVE"
						p.houseselect = "TELE"
					elseif p.houseselect == "FANG"
						p.houseselect = "NVIS"
					elseif p.houseselect == "TASONC"
						p.houseselect = "SHOES"
					elseif p.houseselect == "RADAR"
						p.houseselect = "RAIDO"
					elseif p.houseselect == "BOMB"
						p.houseselect = "TBOMB"
					elseif p.houseselect == "BBOMB"
						p.houseselect = "HELMET"
					elseif p.houseselect == "NAPALM"
						p.houseselect = "ROBOT"
					elseif p.houseselect == "TELE"
						p.houseselect = "GLOVE"
					elseif p.houseselect == "NVIS"
						p.houseselect = "FANG"
					elseif p.houseselect == "SHOES"
						p.houseselect = "TASONC"
					elseif p.houseselect == "RAIDO"
						p.houseselect = "RADAR"
					end
				end
				if p.downtapping then
					S_StartSound(nil, sfx_menu1, p)
					if p.houseselect == "BOMB"
						p.houseselect = "TBOMB"
					elseif p.houseselect == "BBOMB"
						p.houseselect = "HELMET"
					elseif p.houseselect == "NAPALM"
						p.houseselect = "ROBOT"
					elseif p.houseselect == "TELE"
						p.houseselect = "GLOVE"
					elseif p.houseselect == "NVIS"
						p.houseselect = "FANG"
					elseif p.houseselect == "SHOES"
						p.houseselect = "TASONC"
					elseif p.houseselect == "RAIDO"
						p.houseselect = "RADAR"
					elseif p.houseselect == "TBOMB"
						p.houseselect = "BOMB"
					elseif p.houseselect == "HELMET"
						p.houseselect = "BBOMB"
					elseif p.houseselect == "ROBOT"
						p.houseselect = "NAPALM"
					elseif p.houseselect == "GLOVE"
						p.houseselect = "TELE"
					elseif p.houseselect == "FANG"
						p.houseselect = "NVIS"
					elseif p.houseselect == "TASONC"
						p.houseselect = "SHOES"
					elseif p.houseselect == "RADAR"
						p.houseselect = "RAIDO"
					end
				end
			end
		else
			player.tailshouseselect = false
		end
	end
end)

//Adjust Flight Time
addHook("AbilitySpecial", function(player)
	local mo = player.mo
	local skin = "tatails"
	
	if not mo
	or mo.skin ~= skin
	or player.charability ~= CA_FLY
	or player.pflags & PF_THOKKED
		return
	end
	
	player.isflying = true
end)

local function IsPlayerTrans(p)
	local state = p.mo.state
	return (state >= S_PLAY_SUPER_TRANS1) and (state <= S_PLAY_SUPER_TRANS6)
end

//Flight Cancel by Sonic12 (Open Assets)
addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.skin == "tatails")
			if not (player.mo.usedown) then
				player.mo.usedown = 0
			end
	   
			if not (player.mo.flydrop) then
				player.mo.flydrop = 0
			end
	  
			if (player.cmd.buttons & BT_CUSTOM1)
			and (player.mo.usedown == 0)
			and not P_IsObjectOnGround(player.mo)
			and player.mo.state ~= S_PLAY_JUMP
			and player.mo.state ~= S_PLAY_FALL
			and player.mo.state ~= S_PLAY_SPRING
			and player.mo.state ~= S_TAILS_PICKUP
			and player.mo.state ~= S_TAILS_PICKUP2
			and player.mo.state ~= S_TAILS_AWAY
			and not P_PlayerInPain(player)
			and player.mo.state ~= S_PLAY_FLY_TIRED
				player.mo.usedown = 1
				player.mo.flydrop = 1
				player.mo.state = S_TAILS_CORK
				player.pflags = $1|PF_JUMPED
			end
			if not (player.cmd.buttons & BT_CUSTOM1)
			and (player.mo.usedown == 1)
				player.mo.usedown = 0
			end
		end
		
	--Bomb Throw Stuff
		if player.mo and player.mo.skin == "tatails"
		and not player.tailsroboting
		and not player.tailssubbing
			
			-- bomb cooldown so you can't just spam it
			if player.bombcooldown == nil
				player.bombcooldown = 0
			-- deplete timer
			elseif player.bombcooldown > 0
				player.bombcooldown = $-1
			end
			
			if not (player.mo.fire)
				player.mo.fire = 0
			end
			
			if not (player.powers[pw_carry]) 
			and not (player.pflags & PF_STASIS) 
			and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT) 
			and not IsPlayerTrans(player)
			and not player.exiting
			and P_PlayerInPain(player) == false
		    and player.playerstate == PST_LIVE
			and (player.cmd.buttons & BT_ATTACK)
			and player.mo.fire == 0
			and player.bombcooldown == 0
			and player.mo.state ~= S_PLAY_ROLL
			and player.mo.state ~= S_PLAY_SPINDASH then
				if player.inventory[player.tailsselect] == "BOMB"
				and not player.tailsmenuing
					player.mo.fire = 1
					if player.powers[pw_super]
						player.bombcooldown = 0
					else
						player.bombcooldown = 70
					end
					if P_IsObjectOnGround(player.mo) and not player.speed
						player.mo.state = S_BTHROW
					end
					local flame = P_SpawnPlayerMissile(player.mo, MT_FBOMB)
				end
				if player.tailslarge
				and player.inventory[player.tailsselect] == "BBOMB"
				and not player.tailsmenuing
					player.mo.fire = 1
					player.bombcooldown = 4*TICRATE
					if P_IsObjectOnGround(player.mo) and not player.speed
						player.mo.state = S_BTHROW
					end
					local flameb = P_SpawnPlayerMissile(player.mo, MT_LARGEPRO)
				end
				if player.tailstriple
				and player.inventory[player.tailsselect] == "TBOMB"
				and not player.tailsmenuing
					player.mo.fire = 1
					player.bombcooldown = 3*TICRATE
					if P_IsObjectOnGround(player.mo) and not player.speed
						player.mo.state = S_BTHROW
					end
					local flamet1 = P_SPMAngle(player.mo, MT_FBOMB, (player.mo.angle - ANG15), 1)
					local flamet2 = P_SPMAngle(player.mo, MT_FBOMB, (player.mo.angle), 1)
					local flamet3 = P_SPMAngle(player.mo, MT_FBOMB, (player.mo.angle + ANG15), 1)
				end
				if player.tailsnapalm
				and player.inventory[player.tailsselect] == "NAPALM"
				and not player.tailsmenuing then
					player.mo.fire = 1
					player.bombcooldown = 80
					if P_IsObjectOnGround(player.mo) and not player.speed
						player.mo.state = S_BTHROW
					end
					local flamen = P_SpawnPlayerMissile(player.mo, MT_NAPALMPRO)
				end
			end
			if not (player.cmd.buttons & BT_ATTACK)
				player.mo.fire = 0
			end
		end
	end
end)

//Don't Think Shields Will Let You Attack Them Either
addHook("SpinSpecial", function (player)
	if not player.mo
	or player.mo.skin ~= "tatails"
	or not player.mo.health
	or player.exiting
	or not player.realtime
	or player.pflags & PF_STARTDASH
	or player.powers[pw_carry] == CR_NIGHTSMODE
		return
	end
	
	local mo = player.mo
	local shield = player.powers[pw_shield] & ~SH_FIREFLOWER
	if shield == SH_THUNDERCOIN -- If you have the lightning shield
	or shield == SH_FLAMEAURA -- Or if you have a fire shield
	or shield == SH_ATTRACT -- Or if you have a magnet shield
		if (mo.state == S_PLAY_FLY -- And you're not flying
		or mo.state == S_PLAY_FLY_TIRED -- Or tired of flying
		or mo.state == S_PLAY_SPRING -- ....or in the spring animation
		or mo.state == S_PLAY_RIDE -- Or being caried by something...
		or mo.state == S_PLAY_FALL -- Or if you're not already falling
		or P_PlayerInPain(player) -- ...or in pain
		or P_IsObjectOnGround(mo)) -- or you're on the ground
			return
		end
		mo.state = S_PLAY_FALL
	end
end)

addHook("PlayerCanDamage", function(player, mobj)
	if player.mo and player.mo.skin == "tatails"
	and (player.mo.state == S_PLAY_FALL
	or player.mo.state == S_TAILS_CORK)
	and (mobj.flags&MF_ENEMY or mobj.flags&MF_BOSS or mobj.flags&MF_MONITOR)
		return false 
	end
	if player.mo and player.mo.skin == "tatails"
	and not P_IsObjectOnGround(player.mo)
	and (player.mo.state == S_PLAY_ROLL or player.mo.state == S_PLAY_SPINDASH)
	and (mobj.flags&MF_ENEMY or mobj.flags&MF_BOSS or mobj.flags&MF_MONITOR)
		return false
	end
	if player.mo and player.mo.skin == "tatails"
	and (player.mo.state == S_HELM or player.mo.state == S_HELMB)
	and (mobj.flags&MF_ENEMY or mobj.flags&MF_BOSS or mobj.flags&MF_MONITOR)
		return true
	end
end, MT_PLAYER)

addHook("MobjThinker", function(flame)
	-- Defines the player
	for player in players.iterate do
		if player.mo.skin ~= "tatails"
			return
		end
		-- Gravity Flip
		if (player.mo.eflags & MFE_VERTICALFLIP)
			flame.eflags = $1|MFE_VERTICALFLIP -- Considers it flipped
			flame.flags2 = $1|MF2_OBJECTFLIP -- Visually flips it upside down
		end
		-- Floor breaking
		if P_IsObjectOnGround(flame) // If the flame is on the ground...
			for x = flame.x, flame.x + flame.radius, flame.radius -- The following will set up variables for floor breaking
				for y = flame.y, flame.y + flame.radius, flame.radius
					local ss = R_PointInSubsector(x,y)
					for fof in ss.sector.ffloors()
						if (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS) // If a breakable floor exists where the flame lands...
							EV_CrumbleChain(ss.sector, fof) -- Breaks that floor
						end
					end
				end
			end
		end
	end
end, MT_FBOMB)

//What Is A Wall????
local wallbreak = function(mobj, sectorthing)
	for fof in sectorthing.ffloors()
		if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
			local foffloor = fof.topheight
			local fofceiling = fof.bottomheight
			if fof.b_slope and fof.b_slope.valid
				fofceiling = P_GetZAt(fof.b_slope, mobj.x, mobj.y)
			end
			if fof.t_slope and fof.t_slope.valid
				foffloor = P_GetZAt(fof.t_slope, mobj.x, mobj.y)
			end
			if foffloor >= mobj.z and fofceiling <= mobj.z+mobj.height
				EV_CrumbleChain(nil, fof)
				if fof.master.flags & ML_EFFECT5
					P_LinedefExecute(P_AproxDistance(fof.master.dx, fof.master.dy)>>FRACBITS, mobj, sectorthing)
				end
				return true
			end
		end
	end
end

//Break The Wall
addHook("MobjLineCollide", function(mobj, line)
	local mlem -- Because :3
	local mlem2 -- Because I'm so :3
	
	if not (line and line.valid and mobj and mobj.valid)
		return
	end
	
	if line.frontsector
	and line.frontsector.valid
		mlem = wallbreak(mobj,line.frontsector)
	end
	
	if line.backsector
	and line.backsector.valid
		mlem2 = wallbreak(mobj, line.backsector)
	end
	
	if mlem
	or mlem2
		P_ExplodeMissile(mobj)
	end
end, MT_FBOMB)

//Tails pipebombs and speeens the chat
addHook("PlayerMsg", function(p, msgtype, target, msg)
    if (msgtype) then return end
    
    local mo = p.mo
    if not ((mo and mo.valid) and mo.health) then return end
    if (mo.skin !="tatails") then return end
    if (mo.state != S_PLAY_STND and mo.state != S_PLAY_WAIT) then return end
    if (mo.tpipebomb) then return end
    if (p.speed) then return end
    if not (P_IsObjectOnGround(mo)) then return end
        
    -- What you typin?
    msg = $:lower()
    if (msg == "pipebomb" and not mo.tpipebomb)
        p.panim = PA_IDLE
        mo.state = S_TPIPE
        mo.tpipebomb = true
		if S_MusicName(p) ~= "PIPEB" then
            S_ChangeMusic("PIPEB", true, p)
		end
    end
	if (msg == "speeen" and not mo.upside)
		p.panim = PA_IDLE
		mo.state = S_UPSIDE
		mo.upside = true
		if S_MusicName(p) ~= "TUPS"
			S_ChangeMusic("TUPS", true, p)
		end
	end
	if (msg == "zzz" and not mo.tasleep)
		p.panim = PA_IDLE
		mo.state = S_TAILS_SLEEP
		mo.tasleep = true
	end
end)

--Lets give TA the victory theme from Tails Skypatrol because why not
local replaceClearMusic = {
	_clear = "TACMP"
}

addHook("MusicChange", function(old, new)
	if (consoleplayer and consoleplayer.valid)
	and skins[consoleplayer.skin].name == "tatails"
		if old ~= new
			local taclear = replaceClearMusic[new]
			if taclear
				return S_MusicName() == taclear or taclear
			end
		end
	end
end)

//HP Things
addHook("TouchSpecial", function(ring, toucher)
	if not ((ring and ring.valid) and (toucher and toucher.valid)) return end
	if toucher.skin == "tatails"
		P_AddPlayerScore(toucher.player, 100)
		S_StartSound(toucher, sfx_taring)
		P_SpawnMobj(ring.x, ring.y, ring.z, MT_SPARK)
		P_GivePlayerRings(toucher.player, 1)
		toucher.player.hp = $ + 1
		P_RemoveMobj(ring)
	end
end, MT_TARING)

//HP Things 2
addHook("MobjDamage", function(target, inf, src, dmg, dmgType)
	if target.skin == "tatails" 
	and not target.player.powers[pw_super] 
	and not target.player.tailssubbing
	and not target.player.tailsroboting
	and not (maptol & TOL_NIGHTS)
	and target.player.tarobohard == 0
		if target.player.powers[pw_shield]
			target.player.powers[pw_flashing] = 50
			P_DoPlayerPain(target.player, src, inf)
			if target.player.tailsroboting
				S_StartSound(target, sfx_dmpain)
			else
				S_StartSound(target, sfx_altow1)
			end
			P_RemoveShield(target.player)
		else
			if target.player.powers[pw_flashing]
				return
			end
			target.player.powers[pw_flashing] = 50
			target.player.hp = $ - 2
			P_DoPlayerPain(target.player, src, inf)
			if target.player.tailsroboting
				S_StartSound(target, sfx_dmpain)
			else
				S_StartSound(target, sfx_altow1)
			end
			if target.player.hp <= 0
				P_KillMobj(target,inf,src)
			end
		end
		return true
	end
end, MT_PLAYER)

//Tails Waiting Controls
/*addHook("PlayerThink", function(player)
	local mo = player.mo
	local skin = "tatails"
	
	if not (mo or mo.valid)
	and mo.skin ~= skin
		return
	end
	
	if mo.state == S_PLAY_WAIT
		if mo.state == S_TAILS_WAIT2
			return
		end
		mo.state = S_TAILS_WAIT
	end
end)*/

//TATails CDSonic Bot Stuff
addHook("PlayerThink", function(bot)
	//Don't do this if you're on multiplayer/netgames dummy
	if netgame or multiplayer
		return
	end
	
	if bot == BT_NONE
		return
	end
	
	local leader = bot.botleader
	if bot.tailsgroove == nil
		bot.tailsgroove = false
	end
	
	if leader -- If player 1 exists
	and leader.mo.skin == "cdsonic" -- And player 1 is controlling CDSonic (since idk how to swap yet)
		if (leader.cmd.buttons & BT_TOSSFLAG)
		and bot.mo.valid
			R_SetPlayerSkin(leader, "tatails")
			R_SetPlayerSkin(bot, "cdsonic")
		end
		if leader.powers[pw_super] -- And if player 1 is super
			if leader.mo.state == S_PLAY_SUPER_TRANS1 -- And entering your transformation state
			and bot.mo.state ~= S_PLAY_SUPER_TRANS1 -- But player 2 isn't
				bot.mo.state = S_PLAY_SUPER_TRANS1 -- Make player 2 enter their transformation state
			end
			bot.charflags = $ | SF_SUPER -- Make player 2 ACTUALLY super
			bot.powers[pw_super] = players[0].powers[pw_super] -- Make the duration last as long as yours
			bot.rings = players[0].rings -- If they have more/less rings, no they don't
		end
		if (leader.mo.state == S_CD_GROOVE or leader.mo.state == S_CD_INFIN) --I'm not putting more comments.. too lazy
		and bot.mo.state ~= S_TPIPE
		and not bot.tailsgroove
			bot.mo.state = S_TPIPE
			bot.tailsgroove = true
		end
		if bot.tailsgroove
			if leader.mo.state ~= S_CD_GROOVE
			or leader.speed
				if leader.mo.state == S_CD_INFIN
					return
				end
				bot.mo.state = S_PLAY_STND
				bot.tailsgroove = false
			end
			if leader.mo.state ~= S_CD_INFIN
			or leader.speed
				if leader.mo.state == S_CD_GROOVE
					return
				end
				bot.mo.state = S_PLAY_STND
				bot.tailsgroove = false
			end
		end
	end
end)